unit Sample3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Blocks, Statsim, ComCtrls;

type
  TForm1 = class(TForm)
    Memo: TMemo;
    Button1: TButton;
    MultiRand: TMultiRand;
    Label1: TLabel;
    ProgressBar: TProgressBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditArrive: TEdit;
    EditServ: TEdit;
    EditSim: TEdit;
    C: TLabel;
    EditClear: TEdit;
    Scheduler1: TScheduler;
    EditArrive2: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    EditServ2: TEdit;
    Entrance: TGenerator;
    Hall: TQueue;
    Barber: TServer;
    ExitDoor: TTerminator;
    Model: TModel;
    procedure Button1Click(Sender: TObject);
    procedure EditArriveExit(Sender: TObject);
    procedure EditServExit(Sender: TObject);
    procedure EditSimExit(Sender: TObject);
    procedure EditClearExit(Sender: TObject);
    procedure Scheduler1BeforeTimeGoOn(Sender: TAggregate);
    procedure Scheduler1Planned(Sender: TAggregate);
    procedure EditArrive2Exit(Sender: TObject);
    procedure EditServ2Exit(Sender: TObject);
    procedure EntranceBeforeTimeGoOn(Sender: TAggregate);
    procedure EntranceExit(Sender: TBlock; Trans: TTransaction);
    procedure EntranceRouting(Sender: TBlock; Trans: TTransaction);
    procedure HallRouting(Sender: TBlock; Trans: TTransaction);
    procedure BarberEnter(Sender: TBlock; Trans: TTransaction);
    procedure BarberRouting(Sender: TBlock; Trans: TTransaction);
    procedure ModelNewTime(Sender: TAggregate; Trans: TTransaction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



var
  Form1: TForm1;
  TArrivalLower: real;    // Arrival time (lower bound)
  TArrivalUpper: real;    // Arrival time (upper bound)
  TServiceLower: real;    // Service time (lower bound)
  TServiceUpper: real;    // Service tiime (upper bound)
  LimitTime: real;        // Simulation time
  ClearTime: real;        // Clearing interval

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
   { Checking all input paramters }
   try
      TArrivalLower:=StrToFloat(Trim(EditArrive.Text));
   except
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
      Exit;
   end;
   if TArrivalLower<=0.0 then
   begin
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
      Exit;
   end;

   try
      TArrivalUpper:=StrToFloat(Trim(EditArrive2.Text));
   except
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive2.SetFocus;
      Exit;
   end;
   if TArrivalUpper<=0.0 then
   begin
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive2.SetFocus;
      Exit;
   end;

   if TArrivalLower>=TArrivalUpper then
   begin
      MessageDlg('Invalid range of arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
      Exit;
   end;

   try
      TServiceLower:=StrToFloat(Trim(EditServ.Text));
   except
      MessageDlg('Invalid service time',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;
   if TServiceLower<=0.0 then
   begin
      MessageDlg('',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;

   try
      TServiceUpper:=StrToFloat(Trim(EditServ2.Text));
   except
      MessageDlg('Invalid service time',mtError,[mbOK],0);
      EditServ2.SetFocus;
      Exit;
   end;
   if TServiceUpper<=0.0 then
   begin
      MessageDlg('',mtError,[mbOK],0);
      EditServ2.SetFocus;
   end;

   if TServiceLower>=TServiceUpper then
   begin
      MessageDlg('Invalid range of service time',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;

   try
      LimitTime:=StrToFloat(Trim(EditSim.Text));
   except
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditSim.SetFocus;
      Exit;
   end;
   if LimitTime<=0.0 then
   begin
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;

   try
      ClearTime:=StrToFloat(Trim(EditClear.Text));
   except
      MessageDlg('Invalid clearing time',mtError,[mbOK],0);
      EditClear.SetFocus;
      Exit;
   end;
   if ClearTime<=0.0 then
   begin
      MessageDlg('Invalid clearing time',mtError,[mbOK],0);
      EditClear.SetFocus;
      Exit;
   end;

   Memo.Lines.Clear;
   Model.Simulate(LimitTime);
   Model.Reset;
end;

procedure TForm1.EditArriveExit(Sender: TObject);
begin
   try
      TArrivalLower:=StrToFloat(Trim(EditArrive.Text));
   except
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
      Exit;
   end;
   if TArrivalLower<=0.0 then
   begin
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive.SetFocus;
   end;
end;

procedure TForm1.EditArrive2Exit(Sender: TObject);
begin
   try
      TArrivalUpper:=StrToFloat(Trim(EditArrive2.Text));
   except
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive2.SetFocus;
      Exit;
   end;
   if TArrivalUpper<=0.0 then
   begin
      MessageDlg('Invalid arrival time',mtError,[mbOK],0);
      EditArrive2.SetFocus;
   end;
end;


procedure TForm1.EditServExit(Sender: TObject);
begin
   try
      TServiceLower:=StrToFloat(Trim(EditServ.Text));
   except
      MessageDlg('Invalid service time',mtError,[mbOK],0);
      EditServ.SetFocus;
      Exit;
   end;
   if TServiceLower<=0.0 then
   begin
      MessageDlg('',mtError,[mbOK],0);
      EditServ.SetFocus;
   end;
end;

procedure TForm1.EditServ2Exit(Sender: TObject);
begin
   try
      TServiceUpper:=StrToFloat(Trim(EditServ2.Text));
   except
      MessageDlg('Invalid service time',mtError,[mbOK],0);
      EditServ2.SetFocus;
      Exit;
   end;
   if TServiceUpper<=0.0 then
   begin
      MessageDlg('',mtError,[mbOK],0);
      EditServ2.SetFocus;
   end;
end;


procedure TForm1.EditSimExit(Sender: TObject);
begin
   try
      LimitTime:=StrToFloat(Trim(EditSim.Text));
   except
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditSim.SetFocus;
      Exit;
   end;
   if LimitTime<=0.0 then
   begin
      MessageDlg('Invalid simulation time',mtError,[mbOK],0);
      EditServ.SetFocus;
   end;
end;

procedure TForm1.EditClearExit(Sender: TObject);
begin
   try
      ClearTime:=StrToFloat(Trim(EditClear.Text));
   except
      MessageDlg('Invalid clearing time',mtError,[mbOK],0);
      EditClear.SetFocus;
      Exit;
   end;
   if ClearTime<=0.0 then
   begin
      MessageDlg('Invalid clearing time',mtError,[mbOK],0);
      EditClear.SetFocus;
   end;
end;

procedure TForm1.Scheduler1BeforeTimeGoOn(Sender: TAggregate);
begin
   Sender.NextTime(ClearTime);
end;

procedure TForm1.Scheduler1Planned(Sender: TAggregate);
begin
   Memo.Lines.Add('Average time in the queue: '+
                  FormatFloat('0.000',Hall.AverageTime)+'      '+
                  FormatFloat('0.00',ModelTime));
   Model.ClearStatistics;
   Sender.NextTime(ClearTime);
end;

procedure TForm1.EntranceBeforeTimeGoOn(Sender: TAggregate);
begin
  Sender.NextTime(0.0);
end;

procedure TForm1.EntranceExit(Sender: TBlock; Trans: TTransaction);
begin
  Sender.NextTime(MultiRand.Uniform(TArrivalLower,TArrivalUpper));
end;

procedure TForm1.EntranceRouting(Sender: TBlock; Trans: TTransaction);
begin
  Sender.PassTo(Hall);
end;

procedure TForm1.HallRouting(Sender: TBlock; Trans: TTransaction);
begin
  Sender.PassTo(Barber);
end;

procedure TForm1.BarberEnter(Sender: TBlock; Trans: TTransaction);
begin
  Sender.NextTime(MultiRand.Uniform(TServiceLower, TServiceUpper));
end;

procedure TForm1.BarberRouting(Sender: TBlock; Trans: TTransaction);
begin
  Sender.PassTo(ExitDoor);
end;

procedure TForm1.ModelNewTime(Sender: TAggregate; Trans: TTransaction);
var  NewPos: integer;
     Ratio: real;
begin
   Ratio:=ModelTime/LimitTime;
   if Ratio>1.0 then Ratio:=1.0;
   NewPos:=Round(Ratio*100.0);
   with ProgressBar do
      if Position<>NewPos then Position:=NewPos;
end;

end.
